#ifndef _UKCScroll_h
#define _UKCScroll_h

/* $Id: Scrollbar.h,v 1.2 90/09/14 11:33:53 rlh2 Rel $ */

/***********************************************************
Copyright 1987, 1988 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

/****************************************************************
 *
 * UKCScrollbar Widget with Thumb markings
 *
 ****************************************************************/


/* Parameters:

 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 background	     Background		Pixel		White
 border		     BorderColor	Pixel		Black
 borderWidth	     BorderWidth	Dimension	1
 centre		     Centre		Boolean		False
 destroyCallback     Callback		Function	NULL
 fillMarks	     FillMarks		Boolean		TRUE
 foreground	     Color		Pixel		Black
 height		     Height		Dimension	length or thickness
 jumpProc	     Callback		Function	NULL
 length		     Length		Dimension	1
 mappedWhenManaged   MappedWhenManaged	Boolean		True
 markColor	     Color		Pixel		Black
 markSize	     Thickness		Dimension	7
 orientation	     Orientation	XtOrientation	XtorientVertical
 reverseVideo	     ReverseVideo	Boolean		False
 scrollDCursor	     Cursor		Cursor		XC_sb_down_arrow
 scrollHCursor	     Cursor		Cursor		XC_sb_h_double_arrow
 scrollLCursor	     Cursor		Cursor		XC_sb_left_arrow
 scrollProc	     Callback		Function	NULL
 scrollRCursor	     Cursor		Cursor		XC_sb_right_arrow
 scrollUCursor	     Cursor		Cursor		XC_sb_up_arrow
 scrollVCursor	     Cursor		Cursor		XC_sb_v_double_arrow
 sensitive	     Sensitive		Boolean		True
 shown		     Shown		float		0.0
 thickness	     Thickness		Dimension	14
 thumb		     Thumb		Pixmap		Grey
 thumbProc	     Callback		Function	NULL
 top		     Top		float		0.0
 width		     Width		Dimension	thickness or length
 x		     Position		Position	0
 y		     Position		Position	0

*/

#include <X11/Xmu/Xmu.h>

#define XtNfillMarks "fillMarks"
#ifndef _XtStringDefs_h_
#define XtNjumpProc "jumpProc"
#define XtNlength "length"
#endif
#define XtNmarkColor "markColor"
#define XtNmarkSize "markSize"
#ifndef _XtStringDefs_h_
#define XtNorientation "orientation"
#define XtNscrollProc "scrollProc"
#define XtNscrollDCursor "scrollDCursor"
#define XtNscrollHCursor "scrollHCursor"
#define XtNscrollLCursor "scrollLCursor"
#define XtNscrollRCursor "scrollRCursor"
#define XtNscrollUCursor "scrollUCursor"
#define XtNscrollVCursor "scrollVCursor"
#define XtNshown "shown"
#define XtNthickness "thickness"
#define XtNthumb "thumb"
#define XtNthumbProc "thumbProc"
#define XtNtop "top"
#endif
#define XtNcentre "centre"

#define XtCFillMarks "FillMarks"
#define XtCShown "Shown"
#define XtCTop "Top"
#define XtCCentre "Centre"

#ifndef _XtStringDefs_h_
#define XtRFloat "Float"
#endif

typedef struct _UKCScrollbarRec	  *UKCScrollbarWidget;
typedef struct _UKCScrollbarClassRec *UKCScrollbarWidgetClass;

extern WidgetClass ukcScrollbarWidgetClass;

void XukcScrollbarSetThumb(); /* scrollBar, top, shown */
/* Widget scrollBar; */
/* float top, shown; */

typedef struct _publicmark {
	double	start_percent;
	double	end_percent;
} *PubMark;

PubMark XukcScrollbarAddMark();
PubMark XukcScrollbarUpdateMark(/* w, mark, start, end */);
void XukcScrollbarDisplayMarks();
void XukcScrollbarRemoveMark();
void XukcScrollbarResetMarks();
void XukcScrollbarSetThumb();

#endif _UKCScroll_h
