/* XmdvTool.h - Public Header file for XmdvTool */

/* Copyright 1994, Matthew O. Ward 
 *
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without fee
 * is granted provided that the above copyright notice appears in all copies.
 * It is provided "as is" without express or implied warranty.
*/

#include <stdio.h>
#include <math.h>
#include <X11/Intrinsic.h>
#include <X11/Wc/WcCreate.h>
#include <X11/Xp/Xp.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Scrollbar.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xukc/ScrollList.h>
#include <X11/StringDefs.h>
#include <DrawingA.h>


/* #define COLOR   1	 is this a color display? */
#define MAXDIM  35	/* maximum dimensions - too lazy to do dynamically */
#define MAXLABEL 60	/* size of label associated with dimension */
#define MINPC 100
#define SPACE .05	/* extra space for bounds to avoid landing on edges */

/* max unsigned short */
#define MAX_USHORT 65535

/* max XColor color value */
#define MAX_XCOL_VALUE MAX_USHORT

/* some toggle constants for brushes and extended display */
#define BR_MOVE 0
#define BR_SIZE 1
#define BR_ON 1
#define BR_OFF 0
#define EX_ON 1
#define EX_OFF 0

#define DSIZE 2	/* size of rectangle drawn for each sample - 1 is too small */
#define MINSCAT 75 /* minimum size of scatterplot box */
#define MINGLYPH 15 /* minimum size of glyph */

#define SBT_SLIDER_WIDTH 20 /* width in pixels of stack brush tool slider */

/* maximum points that can be multi-selected */
#define MAX_MULTI_SEL 2048

/* min/max macros */
#ifndef MIN
# define MIN(X,Y) ((X)<(Y)?(X):(Y))
#endif
#ifndef MAX
# define MAX(X,Y) ((X)>(Y)?(X):(Y))
#endif

/* absolute value macro */
#ifndef ABS
# define ABS(X) ((X)>0?(X):-(X))
#endif

/* display states */
#define STATE_NONE        0
#define STATE_SCATTERPLOT 1
#define STATE_PARCOORD    2
#define STATE_GLYPH       3
#define STATE_HIER        4

/* the maximum number of allowed brushes */
#define MAXBRUSH 4

/* the maximum number of allowed operations */
#define MAXOPER 30

/*
 * BRUSH_COLOR - Another indexing macro.  Given a brush number, returns
 *               the index associated with it.
 *
 * PARAMETERS
 *   B           The brush number
 *
 * RETURNS
 *   Index into color_cells array assocated with the brush
 */
#define BRUSH_COLOR(B) (B)

#define NUM_BRUSH_CELLS (MAXBRUSH)

/* color cell indexes */

#define CCELL_TEXT            (0 + NUM_BRUSH_CELLS)
#define CCELL_DATA            (1 + NUM_BRUSH_CELLS)
#define CCELL_HIGHLIGHT       (2 + NUM_BRUSH_CELLS)
#define CCELL_OVERLAP         (3 + NUM_BRUSH_CELLS)
#define CCELL_PAINT           (4 + NUM_BRUSH_CELLS)
#define CCELL_GRID1           (5 + NUM_BRUSH_CELLS)
#define CCELL_GRID2           (6 + NUM_BRUSH_CELLS)
#define CCELL_GRID3           (7 + NUM_BRUSH_CELLS)
#define CCELL_STAT1           (8 + NUM_BRUSH_CELLS)
#define CCELL_STAT2           (9 + NUM_BRUSH_CELLS)

#define NUM_INTERFACE_CELLS 10

#define NUM_COLOR_CELLS (NUM_BRUSH_CELLS + NUM_INTERFACE_CELLS)

/* an invalid color index */
#define COLOR_NONE 1024

void LoadFile(Widget, caddr_t);







